with WaterHighSensor, WaterLowSensor, Valve, FillValve, DrainValve,
  FaultIntegrator;
--# inherit WaterHighSensor,
--#         WaterLowSensor,
--#         Valve,
--#         FillValve,
--#         DrainValve,
--#         FaultIntegrator;
--# main_program;
procedure Main
   --# global in      WaterHighSensor.State,
   --#                WaterLowSensor.State;
   --#            out FillValve.State,
   --#                DrainValve.State;
   --# derives FillValve.State
   --#    from WaterLowSensor.State
   --# &       DrainValve.State
   --#    from WaterHighSensor.State;
is
   HighIntegrator, LowIntegrator : FaultIntegrator.T;
   HighThreshold                 : constant Positive := 10;
   LowThreshold                  : constant Positive := 10;
   procedure Control
      --# global in      WaterHighSensor.State,
      --#                WaterLowSensor.State;
      --#            out FillValve.State,
      --#                DrainValve.State;
      --#         in out HighIntegrator,
      --#                LowIntegrator;
      --# derives FillValve.State,
      --#         LowIntegrator
      --#    from LowIntegrator,
      --#         WaterLowSensor.State
      --# &       DrainValve.State,
      --#         HighIntegrator
      --#    from HighIntegrator,
      --#         WaterHighSensor.State;
   is
   --# hide Control;
   begin
      null;
   end Control;
begin -- Main
   FaultIntegrator.Init (HighIntegrator, HighThreshold);
   FaultIntegrator.Init (LowIntegrator, LowThreshold);
   FillValve.SetTo (Valve.Shut);
   DrainValve.SetTo (Valve.Shut);
   loop
      Control;
   end loop;
end Main;
